import java.lang.*;

/*
-------------------------------------------------------------------------------
Percolacio
-------------------------------------------------------------------------------
Dades: percent (percentatge de caselles ocupades)
Resultats: Per pantalla, mida de l'illa mes gran
Dades de prova: percent=50 ==> illa mes gran 125
Observacions: El programa te un bug que fa que no funcioni be per a
              percentatges d'ocupacio alts.
-------------------------------------------------------------------------------
*/

public class PercolaCalculs {
	int record,nmax,a[][];

	PercolaCalculs(int aresta,int percent) {
		int i,imax,j,jmax,k,l,n,ln,da,ba,es,dr,b[][];
		a = new int[aresta][aresta];
		b = new int[aresta][aresta];

/* En Java no fa tanta falta distingir entre la mida fisica i logica dels arrays.
   Nosaltres, no obstant, ho fem... Ens limitem, pero, a taulers quadrats. */

		imax=aresta;
		jmax=aresta;

/* Inicialitzem la matriu 'a' */

		for(i=0;i<imax;i++)
			for(j=0;j<jmax;j++)
				a[i][j]=0;

/* Omplim aleatoriament la primera matriu */

		nmax=percent*imax*jmax/100;
		for(n=0;n<nmax;n++) {
			do {
				i=alea(imax);
				j=alea(jmax);
			} while(a[i][j]!=0);
			a[i][j]=1;
		}

/* Ara explorem totes les caselles */

		record=0;
		for(k=0;k<imax;k++)for(l=0;l<jmax;l++) {

/* Posem a zero la matriu 'b' abans de comencar el bucle principal */

			for(i=0;i<imax;i++)for(j=0;j<jmax;j++)b[i][j]=0;

/* Obrir bucle principal */

			n=0;
			do {

/* Guardem el valor antic de n */

				ln=n;

/* Si una casella de 'b' esta ocupada, copiem de 'a' a 'b' el
   contingut de les caselles del voltant */

   				for(i=0;i<imax;i++)for(j=0;j<jmax;j++)if(b[i][j]!=0) {
					da=(i+imax-1)%imax;
					ba=(i+1)%imax;
					es=(j+jmax-1)%jmax;
					dr=(j+1)%jmax;
/*    b[da][es]=a[da][es]; */
					b[da][j]=a[da][j];
/*    b[da][dr]=a[da][dr]; */
					b[i][es]=a[i][es];
					b[i][j]=a[i][j];
					b[i][dr]=a[i][dr];
/*    b[ba][es]=a[ba][es]; */
					b[ba][j]=a[ba][j];
/*    b[ba][dr]=a[ba][dr]; */
				}

/* Copiem el contingut de la casella (k,l) de 'a' a 'b' tot i que aixo
   nomes es necessari la primera passada */

				b[k][l]=a[k][l];

/* Ara contem el nombre de caselles ocupades a la matriu 'b' */

				n=0;
				for(i=0;i<imax;i++)for(j=0;j<jmax;j++)if(b[i][j]!=0)n++;

/* Tancar bucle principal */

				} while(n!=ln);

			if(n>record)record=n;

/* Explorem la seguent casella (k,l) */

		}
	}

	public int alea(int i) {
		double a;
		int j,k;

		a = 1000.0*Math.random();
		k = (int) a;
		j = k % i;
		return j;
	}
}

